#!/usr/bin/env node
(()=>{"use strict";var e={n:t=>{var s=t&&t.__esModule?()=>t.default:()=>t;return e.d(s,{a:s}),s},d:(t,s)=>{for(var a in s)e.o(s,a)&&!e.o(t,a)&&Object.defineProperty(t,a,{enumerable:!0,get:s[a]})},o:(e,t)=>Object.prototype.hasOwnProperty.call(e,t)};const t=require("git-add-then-commit/package.json");var s=e.n(t);const a=require("path");var o=e.n(a);const i=require("yargs/yargs");var r=e.n(i);const n=require("debug");var l=e.n(n);const c=require("simple-git");var p=e.n(c);const f=require("common-ancestor-path");var m=e.n(f);const u=require("execa");var g=e.n(u);const{name:d}=s(),h=l()(`${d}:git-lib`);async function w(){const{files:e}=await p()().status(),t=e.filter((e=>!["?"," "].includes(e.index))).flatMap((e=>e.path.split(" -> ")));return h("getStagedPaths: saw file paths: %O",e),h("getStagedPaths: returning: %O",t),t}async function y(e){const t=(await Promise.all([g()("git",["diff","--name-only","--",e]),g()("git",["diff","--staged","--name-only","--",e])])).reduce(((e,{stdout:t})=>[...e,...t.split("\n")]),[]).filter(Boolean);h(`fullname: combined stdout array:\n"${t}"`);const s=Array.from(new Set(t));if(!s.length)throw new Error(`path "${e}" does not refer to any staged files`);const a=s.length>1?{ambiguous:!0,files:s}:{ambiguous:!1,file:s[0]};return h("fullname: computed files (from stdout): %O",s),h("fullname: result: %O",a),a}const{name:b}=s(),{parse:v,basename:$}=o(),E=l()(`${b}:parse`),O=RegExp("^[\\s|*]*(BREAKING|BREAKING CHANGE|BREAKING CHANGES)[:\\s]+(.*)","im"),{name:S}=s(),x=l()(`${S}:cli`);(({program:e,parse:t})=>{t().catch((async t=>{(await e.argv).silent||console.error(`fatal: ${("string"==typeof t?t:t.message).replace(/^fatal: /,"")}`),x.extend("<error>")("%O",t),process.exit(1)}))})(function(e){const t=r()();return t.scriptName("gac").usage('$0 [path1, path2, ...] commit-type commit-scope commit-message\n\nStage any paths provided and then commit all staged files. Running this command is equivalent to running the following git commands by hand:\n  git add path1 path2 ...\n  git commit -m "commit-type(commit-scope): commit-message"').options({"scope-omit":{alias:"o",describe:"Do not include a scope at all",type:"boolean"},"scope-basename":{alias:"b",describe:"Use path1's basename as the scope",type:"boolean"},"scope-as-is":{alias:"a",describe:"Use path1 exactly as typed as the scope",type:"boolean"},"scope-full":{alias:"f",describe:"Use path1 (relative to repo root) as the scope",type:"boolean"},"scope-root":{alias:"r",describe:"Use path1 to derive a photogenic scope",type:"boolean"},silent:{alias:"s",describe:"Nothing will be printed to stdout or stderr",type:"boolean"},force:{describe:"Always stage paths even when doing so could damage the index",type:"boolean"},verify:{alias:"v",describe:"Use --no-verify or -v false to bypass git pre-commit and commit-msg hooks",type:"string",choices:["true","false","simple"],default:"true"}}).string("_").group(["scope-omit","scope-basename","scope-as-is","scope-full","scope-root"],"Scope options:").group(["help","version","silent","force","verify"],"Other options:").epilogue("See the full documentation for more details: https://bit.ly/3AdNSAU").example([['$0 path/to/file1 feat - "new feature"','Stages file1 & commits as "feat: new feature"'],['$0 path file2 feat -- "new feature"','Stages file1 & file2 & commits as "feat(file1): new feature"'],['$0 path feat --scope-as-is "feature"','Stages file1 & commits as "feat(path): feature"'],['$0 path feat --scope-full "new feature"','Stages file1 & commits as "feat(path/to/file1): new feature"'],['$0 path feat --scope-root "new feature"','Stages file1 & file2 & commits as "feat(path): new feature"'],['$0 chore scripts "update var names"','Commits (all staged files) as "chore(scripts): update var names"']]).strictOptions(),{program:t,parse:async e=>{var s;e=(null!==(s=e)&&void 0!==s&&s.length?e:process.argv.slice(2)).map((e=>"-"==e?"-o":"--"==e?"-b":"---"==e?"-r":"--no-verify"==e?"-v=false":e)),E("saw argv: %O",e);const a=await t.parse(e);let o=!1;const i=["scopeOmit","scopeBasename","scopeAsIs","scopeFull","scopeRoot"].filter((e=>e in a)).length,r=(o=!!i)?2:3;if(i>1)throw new Error("only one scope option is allowed. See --help for details");if(a._.length<r)throw new Error("must pass all required arguments. See --help for details");if(!await async function(){return p()().checkIsRepo()}())throw new Error("not a git repository (or any of the parent directories): .git");const n=await w();if(E("pre-staged paths: %O",n),a._.length==r&&!n.length)throw new Error("must stage a file or pass a path. See --help for details");const l=Array.from(a._).map(String);let c=l.splice(0,l.length-(o?2:3));const[f,u,d]=o?[l[0],,l[1]]:l,b=await async function(){return g()("git",["rev-parse","--show-toplevel"]).then((e=>e.stdout))}(),S=f.toLowerCase();let x=`${S}(${u}): ${d}`;if(E(`repo root dir: ${b}`),E(`initial message: ${x}`),c=c.map((e=>e.startsWith("::")?`${b}/packages/${e.slice(2)}`:e)),n.length)if(a.force)E("WARNING: skipping dangerous operation check!");else if(E("performing dangerous operation check"),(await Promise.allSettled(c.map((e=>y(e))))).filter((e=>"fulfilled"==e.status)).flatMap((({value:e})=>e.ambiguous?e.files:e.file)).some((e=>n.includes(e))))throw new Error('dangerous operation rejected: "git add" could clobber index state (can be overridden with --force)');await async function(e){h("stagePaths: adding (staging) paths: %O",e),e.length&&await p()().add(e)}(c);const A=await w();if(!A.length)throw new Error("assert failed: nothing to commit");if(!u)if(E("deriving commit scope based on rules: %O",a),a.scopeOmit)E("deriving as omit"),x=`${S}: ${d}`;else{let e;if(a.scopeBasename){if(E("deriving as basename"),c.length){const t=c[0],s=await y(t);if(s.ambiguous)throw new Error("use of --scope-basename with an ambiguous path");e=$(s.file)}else{if(1!=A.length)throw new Error("use of --scope-basename with multiple staged files is ambiguous");e=$(A[0])}e=e.toLowerCase()}else if(a.scopeFull||a.scopeRoot){const t=a.scopeRoot?"root":"full";E(`deriving as ${t}`);const s=e=>e.split(".").filter(Boolean)[0]||e,o=e=>{const s=function(e){const t=m()(...e)||null;return h(`commonAncestor: computed ancestor: ${t}`),t}(e);if(!s)throw new Error(`use of --scope-${t} is ambiguous without common ${a.scopeFull?"non-root":"first or second"} ancestor`);return s};if(c.length){const t=await y(c[0]);if(t.ambiguous)e=o(t.files);else{const s=v(t.file);e=a.scopeRoot&&!s.dir?s.name:t.file}}else e=1==A.length?A[0]:o(A);if(e=e.toLowerCase(),a.scopeRoot){const t=e.split("/").filter(Boolean);e.startsWith("packages/")&&t.length>2?e=`packages/${t[1]}`:(e.startsWith("external-scripts")&&(t[0]="externals"),e=t[0],t[1]&&t[0]==S&&(t[2]?e=t[1]:(e=s(t[1]),"index"==e&&(e=""))),e=s(e))}e==S&&(e="")}else{if(E("deriving as as-is"),!c.length)throw new Error("use of --scope-as-is without path argument is ambiguous");e=c[0]}x=S+(e?`(${e}): `:": ")+d}return(e=>O.test(e))(d)&&(x=x.slice(0,x.indexOf(":"))+"!"+x.slice(x.indexOf(":"))),await async function(e,t=!0,s=!1){h(`makeCommit: pipe output: ${t}`),h(`makeCommit: no-verify: ${s}`),h("makeCommit: creating commit with message: %O",e);const a=!0===s?["--no-verify"]:[];await g()("git",["commit","-m",e,...a],{...t?{stdio:"inherit"}:{stdio:"pipe"},..."simple"===s?{env:{GAC_VERIFY_SIMPLE:"true"}}:{}}).catch((()=>{throw new Error((t?"":"silent ")+"commit operation failed")}))}(x,!a.silent,"simple"===a.verify?"simple":"false"===a.verify||!!a.noVerify),a}}}())})();