(()=>{"use strict";var e={n:t=>{var o=t&&t.__esModule?()=>t.default:()=>t;return e.d(o,{a:o}),o},d:(t,o)=>{for(var s in o)e.o(o,s)&&!e.o(t,s)&&Object.defineProperty(t,s,{enumerable:!0,get:o[s]})},o:(e,t)=>Object.prototype.hasOwnProperty.call(e,t),r:e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})}},t={};e.r(t),e.d(t,{configureProgram:()=>A});const o=require("git-add-then-commit/package.json");var s=e.n(o);const a=require("path");var i=e.n(a);const r=require("yargs/yargs");var n=e.n(r);const l=require("debug");var c=e.n(l);const p=require("simple-git");var f=e.n(p);const m=require("common-ancestor-path");var u=e.n(m);const g=require("execa");var d=e.n(g);const{name:h}=s(),w=c()(`${h}:git-lib`);async function y(){const{files:e}=await f()().status(),t=e.filter((e=>!["?"," "].includes(e.index))).flatMap((e=>e.path.split(" -> ")));return w("getStagedPaths: saw file paths: %O",e),w("getStagedPaths: returning: %O",t),t}async function b(e){const t=(await Promise.all([d()("git",["diff","--name-only","--",e]),d()("git",["diff","--staged","--name-only","--",e])])).reduce(((e,{stdout:t})=>[...e,...t.split("\n")]),[]).filter(Boolean);w(`fullname: combined stdout array:\n"${t}"`);const o=Array.from(new Set(t));if(!o.length)throw new Error(`path "${e}" does not refer to any staged files`);const s=o.length>1?{ambiguous:!0,files:o}:{ambiguous:!1,file:o[0]};return w("fullname: computed files (from stdout): %O",o),w("fullname: result: %O",s),s}const{name:v}=s(),{parse:$,basename:S}=i(),E=c()(`${v}:parse`),O=RegExp("^[\\s|*]*(BREAKING|BREAKING CHANGE|BREAKING CHANGES)[:\\s]+(.*)","im");function A(e){const t=e||n()();return t.scriptName("gac").usage('$0 [path1, path2, ...] commit-type commit-scope commit-message\n\nStage any paths provided and then commit all staged files. Running this command is equivalent to running the following git commands by hand:\n  git add path1 path2 ...\n  git commit -m "commit-type(commit-scope): commit-message"').options({"scope-omit":{alias:"o",describe:"Do not include a scope at all",type:"boolean"},"scope-basename":{alias:"b",describe:"Use path1's basename as the scope",type:"boolean"},"scope-as-is":{alias:"a",describe:"Use path1 exactly as typed as the scope",type:"boolean"},"scope-full":{alias:"f",describe:"Use path1 (relative to repo root) as the scope",type:"boolean"},"scope-root":{alias:"r",describe:"Use path1 to derive a photogenic scope",type:"boolean"},silent:{alias:"s",describe:"Nothing will be printed to stdout or stderr",type:"boolean"},force:{describe:"Always stage paths even when doing so could damage the index",type:"boolean"},verify:{alias:"v",describe:"Use --no-verify or -v false to bypass git pre-commit and commit-msg hooks",type:"string",choices:["true","false","simple"],default:"true"}}).string("_").group(["scope-omit","scope-basename","scope-as-is","scope-full","scope-root"],"Scope options:").group(["help","version","silent","force","verify"],"Other options:").epilogue("See the full documentation for more details: https://bit.ly/3AdNSAU").example([['$0 path/to/file1 feat - "new feature"','Stages file1 & commits as "feat: new feature"'],['$0 path file2 feat -- "new feature"','Stages file1 & file2 & commits as "feat(file1): new feature"'],['$0 path feat --scope-as-is "feature"','Stages file1 & commits as "feat(path): feature"'],['$0 path feat --scope-full "new feature"','Stages file1 & commits as "feat(path/to/file1): new feature"'],['$0 path feat --scope-root "new feature"','Stages file1 & file2 & commits as "feat(path): new feature"'],['$0 chore scripts "update var names"','Commits (all staged files) as "chore(scripts): update var names"']]).strictOptions(),{program:t,parse:async e=>{var o;e=(null!==(o=e)&&void 0!==o&&o.length?e:process.argv.slice(2)).map((e=>"-"==e?"-o":"--"==e?"-b":"---"==e?"-r":"--no-verify"==e?"-v=false":e)),E("saw argv: %O",e);const s=await t.parse(e);let a=!1;const i=["scopeOmit","scopeBasename","scopeAsIs","scopeFull","scopeRoot"].filter((e=>e in s)).length,r=(a=!!i)?2:3;if(i>1)throw new Error("only one scope option is allowed. See --help for details");if(s._.length<r)throw new Error("must pass all required arguments. See --help for details");if(!await async function(){return f()().checkIsRepo()}())throw new Error("not a git repository (or any of the parent directories): .git");const n=await y();if(E("pre-staged paths: %O",n),s._.length==r&&!n.length)throw new Error("must stage a file or pass a path. See --help for details");const l=Array.from(s._).map(String);let c=l.splice(0,l.length-(a?2:3));const[p,m,g]=a?[l[0],,l[1]]:l,h=await async function(){return d()("git",["rev-parse","--show-toplevel"]).then((e=>e.stdout))}(),v=p.toLowerCase();let A=`${v}(${m}): ${g}`;if(E(`repo root dir: ${h}`),E(`initial message: ${A}`),c=c.map((e=>e.startsWith("::")?`${h}/packages/${e.slice(2)}`:e)),n.length)if(s.force)E("WARNING: skipping dangerous operation check!");else if(E("performing dangerous operation check"),(await Promise.allSettled(c.map((e=>b(e))))).filter((e=>"fulfilled"==e.status)).flatMap((({value:e})=>e.ambiguous?e.files:e.file)).some((e=>n.includes(e))))throw new Error('dangerous operation rejected: "git add" could clobber index state (can be overridden with --force)');await async function(e){w("stagePaths: adding (staging) paths: %O",e),e.length&&await f()().add(e)}(c);const x=await y();if(!x.length)throw new Error("assert failed: nothing to commit");if(!m)if(E("deriving commit scope based on rules: %O",s),s.scopeOmit)E("deriving as omit"),A=`${v}: ${g}`;else{let e;if(s.scopeBasename){if(E("deriving as basename"),c.length){const t=c[0],o=await b(t);if(o.ambiguous)throw new Error("use of --scope-basename with an ambiguous path");e=S(o.file)}else{if(1!=x.length)throw new Error("use of --scope-basename with multiple staged files is ambiguous");e=S(x[0])}e=e.toLowerCase()}else if(s.scopeFull||s.scopeRoot){const t=s.scopeRoot?"root":"full";E(`deriving as ${t}`);const o=e=>e.split(".").filter(Boolean)[0]||e,a=e=>{const o=function(e){const t=u()(...e)||null;return w(`commonAncestor: computed ancestor: ${t}`),t}(e);if(!o)throw new Error(`use of --scope-${t} is ambiguous without common ${s.scopeFull?"non-root":"first or second"} ancestor`);return o};if(c.length){const t=await b(c[0]);if(t.ambiguous)e=a(t.files);else{const o=$(t.file);e=s.scopeRoot&&!o.dir?o.name:t.file}}else e=1==x.length?x[0]:a(x);if(e=e.toLowerCase(),s.scopeRoot){const t=e.split("/").filter(Boolean);e.startsWith("packages/")&&t.length>2?e=`packages/${t[1]}`:(e.startsWith("external-scripts")&&(t[0]="externals"),e=t[0],t[1]&&t[0]==v&&(t[2]?e=t[1]:(e=o(t[1]),"index"==e&&(e=""))),e=o(e))}e==v&&(e="")}else{if(E("deriving as as-is"),!c.length)throw new Error("use of --scope-as-is without path argument is ambiguous");e=c[0]}A=v+(e?`(${e}): `:": ")+g}return(e=>O.test(e))(g)&&(A=A.slice(0,A.indexOf(":"))+"!"+A.slice(A.indexOf(":"))),await async function(e,t=!0,o=!1){w(`makeCommit: pipe output: ${t}`),w(`makeCommit: no-verify: ${o}`),w("makeCommit: creating commit with message: %O",e);const s=!0===o?["--no-verify"]:[];await d()("git",["commit","-m",e,...s],{...t?{stdio:"inherit"}:{stdio:"pipe"},..."simple"===o?{env:{GAC_VERIFY_SIMPLE:"true"}}:{}}).catch((()=>{throw new Error((t?"":"silent ")+"commit operation failed")}))}(A,!s.silent,"simple"===s.verify?"simple":"false"===s.verify||!!s.noVerify),s}}}module.exports=t})();